set deet_version 1.0a

### 1. Setup variables and read procedures

global deet_library deetnub_library

set deet_library $env(DEET_LIBRARY)
set deetnub_library $deet_library/$env(DEET_NUB)
set debug_target $env(DEET_TARGET)
set debug_args $env(DEET_ARGS)

source $deet_library/shpat.tcl
if {[sh_vnull DeetSourcePath]} {set DeetSourcePath ""}

global DeetGraphical		; # If we are using wish as opposed to tclsh
global DeetSource		; # Map from source name to source location
global DeetOptActive		; # If window is "active"
global DeetOptNumber		; # If window should number lines
global DeetOptButtons		; # If window should show buttons
global DeetLocation		; # Currently stopped location

global breakpoint
global watch

set DeetMode ""
set DeetSourcePath "$DeetSourcePath:$env(PWD)"
set DeetFrame ""
set DeetLocation ""
set DeetSeqNum 0
set DeetLastStack ""

if {! [sh_vnull tk_version]} {
	source $deet_library/widgets.tcl
	placard_create .placard $deet_library/deet.gif

	placard_label "Loading nub..."
	source $deetnub_library/nub.tcl
	source $deet_library/window.tcl
	source $deet_library/control.tcl
	source $deet_library/sym.tcl
	source $deet_library/stack.tcl

	wm withdraw .
	set DeetGraphical 1
	placard_label "Loading Extensions..."
	# Extra stuff
	catch {
		foreach i [glob $deet_library/ext/*.ext] {
			source $i
		}
	}
	placard_label "Loading target..."
} else {
	puts "Loading target..."
	source $deetnub_library/nub.tcl
	source $deet_library/deet.tcl
	set DeetGraphical 0
}

### 2. Open the initial target

if {$debug_target != ""} {
	if {[catch {opentarget $debug_target $debug_args} err]} {
		puts stderr $err
		exit
	}
	# The next command can be really slow... may no be worth having
	catch {
		foreach i [deet_sym -f] {set DeetSource($i) $i}
	}
	set mainfile [findfunc main]
}

### 2. Finalize loading for UI

if {$DeetGraphical} {
	set w [debugwin_create]
	catch {debugwin_setfile $w $mainfile}
	placard_destroy .placard
	message_set $w.message "Deet, Version $deet_version"
}
